diagrams-lib-1.4.2: Embedded domain-specific language for declarative graphics

Copyright | (c) 2014 diagrams-lib team (see LICENSE)
License | BSD-style (see LICENSE)
Maintainer | diagrams-discuss@googlegroups.com
Safe Haskell | None
Language | Haskell2010

Diagrams.Attributes.Compile

Description

XXX

Synopsis

- class (AttributeClass (AttrType code), Typeable (PrimType code)) => SplitAttribute code where
  - type AttrType code :: *
  - type PrimType code :: *
- splitAttr :: forall code b v n a. SplitAttribute code => code -> RTree b v n a -> RTree b v n a

# Documentation

class (AttributeClass (AttrType code), Typeable (PrimType code)) => SplitAttribute code where Source #

Minimal complete definition

primOK

Associated Types

type AttrType code :: * Source #

type PrimType code :: * Source #

Methods

primOK :: code -> PrimType code -> Bool Source #

splitAttr :: forall code b v n a. SplitAttribute code => code -> RTree b v n a -> RTree b v n a Source #

Push certain attributes down until they are at the roots of trees containing only "safe" nodes. In particular this is used to push fill attributes down until they are over only loops; see `splitFills`.